/*
Copyright (C) 2003-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include "rgError.h"
#include <string.h>
#include <stdio.h>

#define SET_ERRSTR(s) \
	strncpy( gblErrorStringBuffer, s, MAX_ERROR_STRING_LENGTH - 1); \
	gblErrorStringBuffer[ MAX_ERROR_STRING_LENGTH - 1] = '\0'

char gblErrorStringBuffer[ MAX_ERROR_STRING_LENGTH];

char *rgErrorString( int p_error)
{
	switch( p_error) {
	case RGERR_SUCCESS:
		SET_ERRSTR( "Success (no error)"); break;

	case RGERR_FAIL:
		SET_ERRSTR( "General failure"); break;

	case RGERR_COULD_NOT_OPEN_FILE:
		SET_ERRSTR( "Could not open file"); break;

	case RGERR_COULD_NOT_FIND_FILE:
		SET_ERRSTR( "Could not find file"); break;

	case RGERR_NO_ALLOC:
		SET_ERRSTR( "Could not allocate memory"); break;

	case RGERR_BAD_PARAM:
		SET_ERRSTR( "Invalid parameter passed"); break;

	case RGERR_READ_FROM_FILE:
		SET_ERRSTR( "Could not read from file"); break;

	case RGERR_WRITE_TO_FILE:
		SET_ERRSTR( "Could not write to file"); break;

	case RGERR_STREAM_BAD:
		SET_ERRSTR( "Stream is bad"); break;

	case RGERR_STREAM_FAILS:
		SET_ERRSTR( "Stream I/O failed"); break;

	case RGERR_EOF:
		SET_ERRSTR( "End of File (EOF)"); break;

	default:
		sprintf( gblErrorStringBuffer,
			"Undefined error %d", p_error);
		break;	
	}
	
	return gblErrorStringBuffer;
}
